/*----- PROTECTED REGION ID(Agilent4uhv.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent4uhv.h
//
// description : Include file for the Agilent4uhv class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.9 $
// $Date: 2018-05-10 08:04:51 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent4uhv_H
#define Agilent4uhv_H

#include <tango.h>
#include <Serial2Client.h>

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv.h

/**
 *  Agilent4uhv class description:
 *    
 */

namespace Agilent4uhv_ns
{
/*----- PROTECTED REGION ID(Agilent4uhv::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
#define MAX_WINDOWS 2100 /* Necessary fot the 206 + channel trick */
enum windowType { READ_WINDOW = 0x30, WRITE_WINDOW = 0x31 };
class Cache {
	omni_mutex mutex[MAX_WINDOWS];
	vector<unsigned char> data[MAX_WINDOWS];
	Cache(const Cache &source);
public:
	Cache() {}
	void get(const int index, vector<unsigned char> &v) {
		assert(index > 0 && index < MAX_WINDOWS);
		omni_mutex_lock guard(mutex[index]);
		v = data[index];
	}
	void set(const int index, const vector<unsigned char> &v) {
		assert(index > 0 && index < MAX_WINDOWS);
		omni_mutex_lock guard(mutex[index]);
		data[index] = v;
	}
};

class Agilent4uhvWorker;

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Additional Class Declarations

class Agilent4uhv : public Serial2Client_ns::Serial2Client
{

/*----- PROTECTED REGION ID(Agilent4uhv::Data Members) ENABLED START -----*/

//	Add your own data members
	vector<string> channels;
	string init_error;

public:
	omni_mutex iomutex;

	Agilent4uhvWorker *worker;
	vector<int> polled_windows;
	Cache cache;

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Data Members

//	Device property data members
public:
	//	PollingSleep:	Sleep between hardware requests made by internal thread
	Tango::DevLong	pollingSleep;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevString	*attr_Model_read;
	Tango::DevString	*attr_SerialNumber_read;
	Tango::DevDouble	*attr_TemperatureFan_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent4uhv(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent4uhv(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Agilent4uhv(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Agilent4uhv() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Agilent4uhv::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Model related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Model(Tango::Attribute &attr);
	virtual bool is_Model_allowed(Tango::AttReqType type);
/**
 *	Attribute SerialNumber related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_SerialNumber(Tango::Attribute &attr);
	virtual bool is_SerialNumber_allowed(Tango::AttReqType type);
/**
 *	Attribute TemperatureFan related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_TemperatureFan(Tango::Attribute &attr);
	virtual bool is_TemperatureFan_allowed(Tango::AttReqType type);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute HVX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevState
	 *	Attr type:	Scalar
	 */
	virtual void read_HVX(Tango::Attribute &attr);
	virtual bool is_HVX_allowed(Tango::AttReqType type);
	void add_HVX_dynamic_attribute(string attname);
	void remove_HVX_dynamic_attribute(string attname);
	Tango::DevState *get_HVX_data_ptr(string &name);
	map<string,Tango::DevState>	   HVX_data;

	/**
	 *	Attribute DeviceNumberX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_DeviceNumberX(Tango::Attribute &attr);
	virtual void write_DeviceNumberX(Tango::WAttribute &attr);
	virtual bool is_DeviceNumberX_allowed(Tango::AttReqType type);
	void add_DeviceNumberX_dynamic_attribute(string attname);
	void remove_DeviceNumberX_dynamic_attribute(string attname);
	Tango::DevLong *get_DeviceNumberX_data_ptr(string &name);
	map<string,Tango::DevLong>	   DeviceNumberX_data;

	/**
	 *	Attribute PowerMaxX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_PowerMaxX(Tango::Attribute &attr);
	virtual void write_PowerMaxX(Tango::WAttribute &attr);
	virtual bool is_PowerMaxX_allowed(Tango::AttReqType type);
	void add_PowerMaxX_dynamic_attribute(string attname);
	void remove_PowerMaxX_dynamic_attribute(string attname);
	Tango::DevLong *get_PowerMaxX_data_ptr(string &name);
	map<string,Tango::DevLong>	   PowerMaxX_data;

	/**
	 *	Attribute VTargetX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_VTargetX(Tango::Attribute &attr);
	virtual void write_VTargetX(Tango::WAttribute &attr);
	virtual bool is_VTargetX_allowed(Tango::AttReqType type);
	void add_VTargetX_dynamic_attribute(string attname);
	void remove_VTargetX_dynamic_attribute(string attname);
	Tango::DevLong *get_VTargetX_data_ptr(string &name);
	map<string,Tango::DevLong>	   VTargetX_data;

	/**
	 *	Attribute IProtectX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_IProtectX(Tango::Attribute &attr);
	virtual void write_IProtectX(Tango::WAttribute &attr);
	virtual bool is_IProtectX_allowed(Tango::AttReqType type);
	void add_IProtectX_dynamic_attribute(string attname);
	void remove_IProtectX_dynamic_attribute(string attname);
	Tango::DevLong *get_IProtectX_data_ptr(string &name);
	map<string,Tango::DevLong>	   IProtectX_data;

	/**
	 *	Attribute SetPointX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_SetPointX(Tango::Attribute &attr);
	virtual void write_SetPointX(Tango::WAttribute &attr);
	virtual bool is_SetPointX_allowed(Tango::AttReqType type);
	void add_SetPointX_dynamic_attribute(string attname);
	void remove_SetPointX_dynamic_attribute(string attname);
	Tango::DevDouble *get_SetPointX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   SetPointX_data;

	/**
	 *	Attribute TemperatureHVX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_TemperatureHVX(Tango::Attribute &attr);
	virtual bool is_TemperatureHVX_allowed(Tango::AttReqType type);
	void add_TemperatureHVX_dynamic_attribute(string attname);
	void remove_TemperatureHVX_dynamic_attribute(string attname);
	Tango::DevDouble *get_TemperatureHVX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   TemperatureHVX_data;

	/**
	 *	Attribute VoltageX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_VoltageX(Tango::Attribute &attr);
	virtual bool is_VoltageX_allowed(Tango::AttReqType type);
	void add_VoltageX_dynamic_attribute(string attname);
	void remove_VoltageX_dynamic_attribute(string attname);
	Tango::DevDouble *get_VoltageX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   VoltageX_data;

	/**
	 *	Attribute CurrentX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_CurrentX(Tango::Attribute &attr);
	virtual bool is_CurrentX_allowed(Tango::AttReqType type);
	void add_CurrentX_dynamic_attribute(string attname);
	void remove_CurrentX_dynamic_attribute(string attname);
	Tango::DevDouble *get_CurrentX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   CurrentX_data;

	/**
	 *	Attribute PressureX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_PressureX(Tango::Attribute &attr);
	virtual bool is_PressureX_allowed(Tango::AttReqType type);
	void add_PressureX_dynamic_attribute(string attname);
	void remove_PressureX_dynamic_attribute(string attname);
	Tango::DevDouble *get_PressureX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   PressureX_data;

	/**
	 *	Attribute StateX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevState
	 *	Attr type:	Scalar
	 */
	virtual void read_StateX(Tango::Attribute &attr);
	virtual bool is_StateX_allowed(Tango::AttReqType type);
	void add_StateX_dynamic_attribute(string attname);
	void remove_StateX_dynamic_attribute(string attname);
	Tango::DevState *get_StateX_data_ptr(string &name);
	map<string,Tango::DevState>	   StateX_data;

	/**
	 *	Attribute StatusX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar
	 */
	virtual void read_StatusX(Tango::Attribute &attr);
	virtual bool is_StatusX_allowed(Tango::AttReqType type);
	void add_StatusX_dynamic_attribute(string attname);
	void remove_StatusX_dynamic_attribute(string attname);
	Tango::DevString *get_StatusX_data_ptr(string &name);
	map<string,Tango::DevString>	   StatusX_data;

	/**
	 *	Attribute AutoStartX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_AutoStartX(Tango::Attribute &attr);
	virtual void write_AutoStartX(Tango::WAttribute &attr);
	virtual bool is_AutoStartX_allowed(Tango::AttReqType type);
	void add_AutoStartX_dynamic_attribute(string attname);
	void remove_AutoStartX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_AutoStartX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   AutoStartX_data;

	/**
	 *	Attribute ProtectX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_ProtectX(Tango::Attribute &attr);
	virtual void write_ProtectX(Tango::WAttribute &attr);
	virtual bool is_ProtectX_allowed(Tango::AttReqType type);
	void add_ProtectX_dynamic_attribute(string attname);
	void remove_ProtectX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_ProtectX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   ProtectX_data;

	/**
	 *	Attribute FixedX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_FixedX(Tango::Attribute &attr);
	virtual void write_FixedX(Tango::WAttribute &attr);
	virtual bool is_FixedX_allowed(Tango::AttReqType type);
	void add_FixedX_dynamic_attribute(string attname);
	void remove_FixedX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_FixedX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   FixedX_data;

	/**
	 *	Attribute StatusSetPointX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_StatusSetPointX(Tango::Attribute &attr);
	virtual bool is_StatusSetPointX_allowed(Tango::AttReqType type);
	void add_StatusSetPointX_dynamic_attribute(string attname);
	void remove_StatusSetPointX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_StatusSetPointX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   StatusSetPointX_data;

	/**
	 *	Attribute InterlockStatusX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_InterlockStatusX(Tango::Attribute &attr);
	virtual bool is_InterlockStatusX_allowed(Tango::AttReqType type);
	void add_InterlockStatusX_dynamic_attribute(string attname);
	void remove_InterlockStatusX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_InterlockStatusX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   InterlockStatusX_data;

	/**
	 *	Attribute StatMaskX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_StatMaskX(Tango::Attribute &attr);
	virtual bool is_StatMaskX_allowed(Tango::AttReqType type);
	void add_StatMaskX_dynamic_attribute(string attname);
	void remove_StatMaskX_dynamic_attribute(string attname);
	Tango::DevLong *get_StatMaskX_data_ptr(string &name);
	map<string,Tango::DevLong>	   StatMaskX_data;

	//--------------------------------------------------------
	/**
	 *	Method      : Agilent4uhv::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:

//	Dynamic commands methods
public:
	/**
	 *	Command OffHVX related method
	 *	Description: 
	 *
	 */
	virtual void off_hvx(Tango::Command &command);
	virtual bool is_OffHVX_allowed(const CORBA::Any &any);
	void add_OffHVX_dynamic_command(string cmdname, bool device);
	void remove_OffHVX_dynamic_command(string cmdname);
	/**
	 *	Command OnHVX related method
	 *	Description: 
	 *
	 */
	virtual void on_hvx(Tango::Command &command);
	virtual bool is_OnHVX_allowed(const CORBA::Any &any);
	void add_OnHVX_dynamic_command(string cmdname, bool device);
	void remove_OnHVX_dynamic_command(string cmdname);

	//--------------------------------------------------------
	/**
	 *	Method      : Agilent4uhv::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Agilent4uhv::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void check_init();

	void init_header(const int win, const windowType type, 
			vector<unsigned char> &header);
	int calc_crc(const vector<unsigned char> &header, 
			const vector<unsigned char> &payload);
	void check_crc(const vector<unsigned char> &header,
			const vector<unsigned char> &payload, 
			const vector<unsigned char> &footer);
	void init_footer(const int computed_crc, vector<unsigned char> &footer);

	void send_message(const int win, const windowType type, 
			const vector<unsigned char> &payload);
	void receive_message(vector<unsigned char> &payload);
	void _send_receive_message(const int win, const windowType type, 
		const vector<unsigned char> &answer, vector<unsigned char> &reply);
	void send_receive_message(const int win, const windowType type, 
		const vector<unsigned char> &answer, vector<unsigned char> &reply);
	void decode(const vector<unsigned char> &payload, bool &data);
	void decode(const vector<unsigned char> &payload, int &data);
	void decode(const vector<unsigned char> &payload, double &data);
	void decode(const vector<unsigned char> &payload, string &data);
	void encode(const bool &data, vector<unsigned char> &payload);
	void encode(const int &data, vector<unsigned char> &payload);
	void encode(const double &data, vector<unsigned char> &payload);
	void encode(const string &data, vector<unsigned char> &payload);
	template<typename T> void read_window(const int win, T &data);
	template<typename T> void _write_window(const int win, const T &data);
	template<typename T> void write_window(const int win, const T &data);
	template<typename T> void read_window_from_cache(const int win, T &data);
	void _read_window_into_cache(const int win);
	void read_window_into_cache(const int win);
	void check_state();

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Agilent4uhv::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions
class Agilent4uhvWorker : public omni_thread, public Tango::LogAdapter
{
	Agilent4uhv *device;
	void* run_undetached(void*);
	volatile bool cont;

public:
	Agilent4uhvWorker(Agilent4uhv *device_) :
		LogAdapter((Tango::DeviceImpl*)device_),
		device(device_), cont(false) {}

	void start() {
		cont = true;
		start_undetached();
	}

	void stop() {
		cont = false;
	}
};


/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Additional Classes Definitions

}	//	End of namespace

#endif   //	Agilent4uhv_H
