/*----- PROTECTED REGION ID(Agilent4uhv::DynAttrUtils.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent4uhvDynAttrUtils.cpp
//
// description : Dynamic attributes utilities file for the Agilent4uhv class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.6 $
// $Date: 2014-10-15 13:23:58 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Agilent4uhv.h>
#include <Agilent4uhvClass.h>

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::DynAttrUtils.cpp

//================================================================
//  Attributes managed are:
//================================================================
//  HVX               |  Tango::DevState	Scalar
//  DeviceNumberX     |  Tango::DevLong	Scalar
//  PowerMaxX         |  Tango::DevLong	Scalar
//  VTargetX          |  Tango::DevLong	Scalar
//  IProtectX         |  Tango::DevLong	Scalar
//  SetPointX         |  Tango::DevDouble	Scalar
//  TemperatureHVX    |  Tango::DevDouble	Scalar
//  VoltageX          |  Tango::DevDouble	Scalar
//  CurrentX          |  Tango::DevDouble	Scalar
//  PressureX         |  Tango::DevDouble	Scalar
//  StateX            |  Tango::DevState	Scalar
//  StatusX           |  Tango::DevString	Scalar
//  AutoStartX        |  Tango::DevBoolean	Scalar
//  ProtectX          |  Tango::DevBoolean	Scalar
//  FixedX            |  Tango::DevBoolean	Scalar
//  StatusSetPointX   |  Tango::DevBoolean	Scalar
//  InterlockStatusX  |  Tango::DevBoolean	Scalar
//  StatMaskX         |  Tango::DevLong	Scalar
//================================================================

//	For compatibility reason, this file (Agilent4uhvDynAttrUtils)
//	manage also the dynamic command utilities.
//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  OffHVX        |  off_hvx
//  OnHVX         |  on_hvx
//================================================================

namespace Agilent4uhv_ns
{
//=============================================================
//	Add/Remove dynamic attribute methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a HVX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_HVX_dynamic_attribute(string attname)
{
	//	Attribute : HVX
	HVXAttrib	*hvx = new HVXAttrib(attname);
	Tango::UserDefaultAttrProp	hvx_prop;
	//	description	not set for HVX
	//	label	not set for HVX
	//	unit	not set for HVX
	//	standard_unit	not set for HVX
	//	display_unit	not set for HVX
	//	format	not set for HVX
	//	max_value	not set for HVX
	//	min_value	not set for HVX
	//	max_alarm	not set for HVX
	//	min_alarm	not set for HVX
	//	max_warning	not set for HVX
	//	min_warning	not set for HVX
	//	delta_t	not set for HVX
	//	delta_val	not set for HVX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_HVX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_HVX_dynamic_attribute
	hvx->set_default_properties(hvx_prop);
	//	Not Polled
	hvx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	HVX_data.insert(make_pair(attname, Tango::UNKNOWN));
	add_attribute(hvx);
}
//--------------------------------------------------------
/**
 *	remove a HVX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_HVX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevState>::iterator ite;
    if ((ite=HVX_data.find(attname))!=HVX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_HVX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_HVX_dynamic_attribute
		HVX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a DeviceNumberX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_DeviceNumberX_dynamic_attribute(string attname)
{
	//	Attribute : DeviceNumberX
	DeviceNumberXAttrib	*devicenumberx = new DeviceNumberXAttrib(attname);
	Tango::UserDefaultAttrProp	devicenumberx_prop;
	//	description	not set for DeviceNumberX
	//	label	not set for DeviceNumberX
	//	unit	not set for DeviceNumberX
	//	standard_unit	not set for DeviceNumberX
	//	display_unit	not set for DeviceNumberX
	//	format	not set for DeviceNumberX
	//	max_value	not set for DeviceNumberX
	//	min_value	not set for DeviceNumberX
	//	max_alarm	not set for DeviceNumberX
	//	min_alarm	not set for DeviceNumberX
	//	max_warning	not set for DeviceNumberX
	//	min_warning	not set for DeviceNumberX
	//	delta_t	not set for DeviceNumberX
	//	delta_val	not set for DeviceNumberX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_DeviceNumberX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_DeviceNumberX_dynamic_attribute
	devicenumberx->set_default_properties(devicenumberx_prop);
	//	Not Polled
	devicenumberx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	DeviceNumberX_data.insert(make_pair(attname, 0));
	add_attribute(devicenumberx);
}
//--------------------------------------------------------
/**
 *	remove a DeviceNumberX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_DeviceNumberX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=DeviceNumberX_data.find(attname))!=DeviceNumberX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_DeviceNumberX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_DeviceNumberX_dynamic_attribute
		DeviceNumberX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a PowerMaxX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_PowerMaxX_dynamic_attribute(string attname)
{
	//	Attribute : PowerMaxX
	PowerMaxXAttrib	*powermaxx = new PowerMaxXAttrib(attname);
	Tango::UserDefaultAttrProp	powermaxx_prop;
	//	description	not set for PowerMaxX
	//	label	not set for PowerMaxX
	powermaxx_prop.set_unit("W");
	//	standard_unit	not set for PowerMaxX
	//	display_unit	not set for PowerMaxX
	//	format	not set for PowerMaxX
	powermaxx_prop.set_max_value("80");
	powermaxx_prop.set_min_value("20");
	//	max_alarm	not set for PowerMaxX
	//	min_alarm	not set for PowerMaxX
	//	max_warning	not set for PowerMaxX
	//	min_warning	not set for PowerMaxX
	//	delta_t	not set for PowerMaxX
	//	delta_val	not set for PowerMaxX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_PowerMaxX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_PowerMaxX_dynamic_attribute
	powermaxx->set_default_properties(powermaxx_prop);
	//	Not Polled
	powermaxx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	PowerMaxX_data.insert(make_pair(attname, 0));
	add_attribute(powermaxx);
}
//--------------------------------------------------------
/**
 *	remove a PowerMaxX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_PowerMaxX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=PowerMaxX_data.find(attname))!=PowerMaxX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_PowerMaxX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_PowerMaxX_dynamic_attribute
		PowerMaxX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a VTargetX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_VTargetX_dynamic_attribute(string attname)
{
	//	Attribute : VTargetX
	VTargetXAttrib	*vtargetx = new VTargetXAttrib(attname);
	Tango::UserDefaultAttrProp	vtargetx_prop;
	//	description	not set for VTargetX
	//	label	not set for VTargetX
	vtargetx_prop.set_unit("V");
	//	standard_unit	not set for VTargetX
	//	display_unit	not set for VTargetX
	//	format	not set for VTargetX
	vtargetx_prop.set_max_value("7000");
	vtargetx_prop.set_min_value("3000");
	//	max_alarm	not set for VTargetX
	//	min_alarm	not set for VTargetX
	//	max_warning	not set for VTargetX
	//	min_warning	not set for VTargetX
	//	delta_t	not set for VTargetX
	//	delta_val	not set for VTargetX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_VTargetX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_VTargetX_dynamic_attribute
	vtargetx->set_default_properties(vtargetx_prop);
	//	Not Polled
	vtargetx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	VTargetX_data.insert(make_pair(attname, 0));
	add_attribute(vtargetx);
}
//--------------------------------------------------------
/**
 *	remove a VTargetX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_VTargetX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=VTargetX_data.find(attname))!=VTargetX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_VTargetX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_VTargetX_dynamic_attribute
		VTargetX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a IProtectX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_IProtectX_dynamic_attribute(string attname)
{
	//	Attribute : IProtectX
	IProtectXAttrib	*iprotectx = new IProtectXAttrib(attname);
	Tango::UserDefaultAttrProp	iprotectx_prop;
	//	description	not set for IProtectX
	//	label	not set for IProtectX
	iprotectx_prop.set_unit("mA");
	//	standard_unit	not set for IProtectX
	//	display_unit	not set for IProtectX
	//	format	not set for IProtectX
	iprotectx_prop.set_max_value("100");
	iprotectx_prop.set_min_value("1");
	//	max_alarm	not set for IProtectX
	//	min_alarm	not set for IProtectX
	//	max_warning	not set for IProtectX
	//	min_warning	not set for IProtectX
	//	delta_t	not set for IProtectX
	//	delta_val	not set for IProtectX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_IProtectX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_IProtectX_dynamic_attribute
	iprotectx->set_default_properties(iprotectx_prop);
	//	Not Polled
	iprotectx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	IProtectX_data.insert(make_pair(attname, 0));
	add_attribute(iprotectx);
}
//--------------------------------------------------------
/**
 *	remove a IProtectX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_IProtectX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=IProtectX_data.find(attname))!=IProtectX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_IProtectX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_IProtectX_dynamic_attribute
		IProtectX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a SetPointX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_SetPointX_dynamic_attribute(string attname)
{
	//	Attribute : SetPointX
	SetPointXAttrib	*setpointx = new SetPointXAttrib(attname);
	Tango::UserDefaultAttrProp	setpointx_prop;
	//	description	not set for SetPointX
	//	label	not set for SetPointX
	//	unit	not set for SetPointX
	//	standard_unit	not set for SetPointX
	//	display_unit	not set for SetPointX
	//	format	not set for SetPointX
	//	max_value	not set for SetPointX
	//	min_value	not set for SetPointX
	//	max_alarm	not set for SetPointX
	//	min_alarm	not set for SetPointX
	//	max_warning	not set for SetPointX
	//	min_warning	not set for SetPointX
	//	delta_t	not set for SetPointX
	//	delta_val	not set for SetPointX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_SetPointX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_SetPointX_dynamic_attribute
	setpointx->set_default_properties(setpointx_prop);
	//	Not Polled
	setpointx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	SetPointX_data.insert(make_pair(attname, 0.0));
	add_attribute(setpointx);
}
//--------------------------------------------------------
/**
 *	remove a SetPointX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_SetPointX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=SetPointX_data.find(attname))!=SetPointX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_SetPointX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_SetPointX_dynamic_attribute
		SetPointX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a TemperatureHVX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_TemperatureHVX_dynamic_attribute(string attname)
{
	//	Attribute : TemperatureHVX
	TemperatureHVXAttrib	*temperaturehvx = new TemperatureHVXAttrib(attname);
	Tango::UserDefaultAttrProp	temperaturehvx_prop;
	//	description	not set for TemperatureHVX
	//	label	not set for TemperatureHVX
	temperaturehvx_prop.set_unit("C");
	//	standard_unit	not set for TemperatureHVX
	//	display_unit	not set for TemperatureHVX
	//	format	not set for TemperatureHVX
	temperaturehvx_prop.set_max_value("200");
	temperaturehvx_prop.set_min_value("0");
	//	max_alarm	not set for TemperatureHVX
	//	min_alarm	not set for TemperatureHVX
	//	max_warning	not set for TemperatureHVX
	//	min_warning	not set for TemperatureHVX
	//	delta_t	not set for TemperatureHVX
	//	delta_val	not set for TemperatureHVX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_TemperatureHVX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_TemperatureHVX_dynamic_attribute
	temperaturehvx->set_default_properties(temperaturehvx_prop);
	//	Not Polled
	temperaturehvx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	TemperatureHVX_data.insert(make_pair(attname, 0.0));
	add_attribute(temperaturehvx);
}
//--------------------------------------------------------
/**
 *	remove a TemperatureHVX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_TemperatureHVX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=TemperatureHVX_data.find(attname))!=TemperatureHVX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_TemperatureHVX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_TemperatureHVX_dynamic_attribute
		TemperatureHVX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a VoltageX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_VoltageX_dynamic_attribute(string attname)
{
	//	Attribute : VoltageX
	VoltageXAttrib	*voltagex = new VoltageXAttrib(attname);
	Tango::UserDefaultAttrProp	voltagex_prop;
	//	description	not set for VoltageX
	//	label	not set for VoltageX
	voltagex_prop.set_unit("V");
	//	standard_unit	not set for VoltageX
	//	display_unit	not set for VoltageX
	//	format	not set for VoltageX
	voltagex_prop.set_max_value("10000");
	voltagex_prop.set_min_value("0");
	//	max_alarm	not set for VoltageX
	//	min_alarm	not set for VoltageX
	//	max_warning	not set for VoltageX
	//	min_warning	not set for VoltageX
	//	delta_t	not set for VoltageX
	//	delta_val	not set for VoltageX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_VoltageX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_VoltageX_dynamic_attribute
	voltagex->set_default_properties(voltagex_prop);
	//	Not Polled
	voltagex->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	VoltageX_data.insert(make_pair(attname, 0.0));
	add_attribute(voltagex);
}
//--------------------------------------------------------
/**
 *	remove a VoltageX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_VoltageX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=VoltageX_data.find(attname))!=VoltageX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_VoltageX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_VoltageX_dynamic_attribute
		VoltageX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a CurrentX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_CurrentX_dynamic_attribute(string attname)
{
	//	Attribute : CurrentX
	CurrentXAttrib	*currentx = new CurrentXAttrib(attname);
	Tango::UserDefaultAttrProp	currentx_prop;
	//	description	not set for CurrentX
	//	label	not set for CurrentX
	currentx_prop.set_unit("A");
	//	standard_unit	not set for CurrentX
	//	display_unit	not set for CurrentX
	currentx_prop.set_format("%1.2E");
	currentx_prop.set_max_value("9E-1");
	currentx_prop.set_min_value("1E-10");
	//	max_alarm	not set for CurrentX
	//	min_alarm	not set for CurrentX
	//	max_warning	not set for CurrentX
	//	min_warning	not set for CurrentX
	//	delta_t	not set for CurrentX
	//	delta_val	not set for CurrentX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_CurrentX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_CurrentX_dynamic_attribute
	currentx->set_default_properties(currentx_prop);
	//	Not Polled
	currentx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	CurrentX_data.insert(make_pair(attname, 0.0));
	add_attribute(currentx);
}
//--------------------------------------------------------
/**
 *	remove a CurrentX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_CurrentX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=CurrentX_data.find(attname))!=CurrentX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_CurrentX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_CurrentX_dynamic_attribute
		CurrentX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a PressureX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_PressureX_dynamic_attribute(string attname)
{
	//	Attribute : PressureX
	PressureXAttrib	*pressurex = new PressureXAttrib(attname);
	Tango::UserDefaultAttrProp	pressurex_prop;
	//	description	not set for PressureX
	//	label	not set for PressureX
	pressurex_prop.set_unit("mbar");
	//	standard_unit	not set for PressureX
	//	display_unit	not set for PressureX
	pressurex_prop.set_format("%1.2E");
	//	max_value	not set for PressureX
	//	min_value	not set for PressureX
	//	max_alarm	not set for PressureX
	//	min_alarm	not set for PressureX
	//	max_warning	not set for PressureX
	//	min_warning	not set for PressureX
	//	delta_t	not set for PressureX
	//	delta_val	not set for PressureX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_PressureX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_PressureX_dynamic_attribute
	pressurex->set_default_properties(pressurex_prop);
	//	Not Polled
	pressurex->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	PressureX_data.insert(make_pair(attname, 0.0));
	add_attribute(pressurex);
}
//--------------------------------------------------------
/**
 *	remove a PressureX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_PressureX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=PressureX_data.find(attname))!=PressureX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_PressureX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_PressureX_dynamic_attribute
		PressureX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a StateX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_StateX_dynamic_attribute(string attname)
{
	//	Attribute : StateX
	StateXAttrib	*statex = new StateXAttrib(attname);
	Tango::UserDefaultAttrProp	statex_prop;
	//	description	not set for StateX
	//	label	not set for StateX
	//	unit	not set for StateX
	//	standard_unit	not set for StateX
	//	display_unit	not set for StateX
	//	format	not set for StateX
	//	max_value	not set for StateX
	//	min_value	not set for StateX
	//	max_alarm	not set for StateX
	//	min_alarm	not set for StateX
	//	max_warning	not set for StateX
	//	min_warning	not set for StateX
	//	delta_t	not set for StateX
	//	delta_val	not set for StateX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_StateX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_StateX_dynamic_attribute
	statex->set_default_properties(statex_prop);
	//	Not Polled
	statex->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	StateX_data.insert(make_pair(attname, Tango::UNKNOWN));
	add_attribute(statex);
}
//--------------------------------------------------------
/**
 *	remove a StateX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_StateX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevState>::iterator ite;
    if ((ite=StateX_data.find(attname))!=StateX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_StateX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_StateX_dynamic_attribute
		StateX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a StatusX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_StatusX_dynamic_attribute(string attname)
{
	//	Attribute : StatusX
	StatusXAttrib	*statusx = new StatusXAttrib(attname);
	Tango::UserDefaultAttrProp	statusx_prop;
	//	description	not set for StatusX
	//	label	not set for StatusX
	//	unit	not set for StatusX
	//	standard_unit	not set for StatusX
	//	display_unit	not set for StatusX
	//	format	not set for StatusX
	//	max_value	not set for StatusX
	//	min_value	not set for StatusX
	//	max_alarm	not set for StatusX
	//	min_alarm	not set for StatusX
	//	max_warning	not set for StatusX
	//	min_warning	not set for StatusX
	//	delta_t	not set for StatusX
	//	delta_val	not set for StatusX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_StatusX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_StatusX_dynamic_attribute
	statusx->set_default_properties(statusx_prop);
	//	Not Polled
	statusx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	char array[1];
	array[0] = '\0';
	StatusX_data.insert(make_pair(attname, array));
	add_attribute(statusx);
}
//--------------------------------------------------------
/**
 *	remove a StatusX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_StatusX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevString>::iterator ite;
    if ((ite=StatusX_data.find(attname))!=StatusX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_StatusX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_StatusX_dynamic_attribute
		StatusX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a AutoStartX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_AutoStartX_dynamic_attribute(string attname)
{
	//	Attribute : AutoStartX
	AutoStartXAttrib	*autostartx = new AutoStartXAttrib(attname);
	Tango::UserDefaultAttrProp	autostartx_prop;
	//	description	not set for AutoStartX
	//	label	not set for AutoStartX
	//	unit	not set for AutoStartX
	//	standard_unit	not set for AutoStartX
	//	display_unit	not set for AutoStartX
	//	format	not set for AutoStartX
	//	max_value	not set for AutoStartX
	//	min_value	not set for AutoStartX
	//	max_alarm	not set for AutoStartX
	//	min_alarm	not set for AutoStartX
	//	max_warning	not set for AutoStartX
	//	min_warning	not set for AutoStartX
	//	delta_t	not set for AutoStartX
	//	delta_val	not set for AutoStartX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_AutoStartX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_AutoStartX_dynamic_attribute
	autostartx->set_default_properties(autostartx_prop);
	//	Not Polled
	autostartx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	AutoStartX_data.insert(make_pair(attname, false));
	add_attribute(autostartx);
}
//--------------------------------------------------------
/**
 *	remove a AutoStartX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_AutoStartX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=AutoStartX_data.find(attname))!=AutoStartX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_AutoStartX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_AutoStartX_dynamic_attribute
		AutoStartX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a ProtectX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_ProtectX_dynamic_attribute(string attname)
{
	//	Attribute : ProtectX
	ProtectXAttrib	*protectx = new ProtectXAttrib(attname);
	Tango::UserDefaultAttrProp	protectx_prop;
	//	description	not set for ProtectX
	//	label	not set for ProtectX
	//	unit	not set for ProtectX
	//	standard_unit	not set for ProtectX
	//	display_unit	not set for ProtectX
	//	format	not set for ProtectX
	//	max_value	not set for ProtectX
	//	min_value	not set for ProtectX
	//	max_alarm	not set for ProtectX
	//	min_alarm	not set for ProtectX
	//	max_warning	not set for ProtectX
	//	min_warning	not set for ProtectX
	//	delta_t	not set for ProtectX
	//	delta_val	not set for ProtectX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_ProtectX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_ProtectX_dynamic_attribute
	protectx->set_default_properties(protectx_prop);
	//	Not Polled
	protectx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	ProtectX_data.insert(make_pair(attname, false));
	add_attribute(protectx);
}
//--------------------------------------------------------
/**
 *	remove a ProtectX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_ProtectX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=ProtectX_data.find(attname))!=ProtectX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_ProtectX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_ProtectX_dynamic_attribute
		ProtectX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a FixedX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_FixedX_dynamic_attribute(string attname)
{
	//	Attribute : FixedX
	FixedXAttrib	*fixedx = new FixedXAttrib(attname);
	Tango::UserDefaultAttrProp	fixedx_prop;
	//	description	not set for FixedX
	//	label	not set for FixedX
	//	unit	not set for FixedX
	//	standard_unit	not set for FixedX
	//	display_unit	not set for FixedX
	//	format	not set for FixedX
	//	max_value	not set for FixedX
	//	min_value	not set for FixedX
	//	max_alarm	not set for FixedX
	//	min_alarm	not set for FixedX
	//	max_warning	not set for FixedX
	//	min_warning	not set for FixedX
	//	delta_t	not set for FixedX
	//	delta_val	not set for FixedX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_FixedX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_FixedX_dynamic_attribute
	fixedx->set_default_properties(fixedx_prop);
	//	Not Polled
	fixedx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	FixedX_data.insert(make_pair(attname, false));
	add_attribute(fixedx);
}
//--------------------------------------------------------
/**
 *	remove a FixedX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_FixedX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=FixedX_data.find(attname))!=FixedX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_FixedX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_FixedX_dynamic_attribute
		FixedX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a StatusSetPointX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_StatusSetPointX_dynamic_attribute(string attname)
{
	//	Attribute : StatusSetPointX
	StatusSetPointXAttrib	*statussetpointx = new StatusSetPointXAttrib(attname);
	Tango::UserDefaultAttrProp	statussetpointx_prop;
	//	description	not set for StatusSetPointX
	//	label	not set for StatusSetPointX
	//	unit	not set for StatusSetPointX
	//	standard_unit	not set for StatusSetPointX
	//	display_unit	not set for StatusSetPointX
	//	format	not set for StatusSetPointX
	//	max_value	not set for StatusSetPointX
	//	min_value	not set for StatusSetPointX
	//	max_alarm	not set for StatusSetPointX
	//	min_alarm	not set for StatusSetPointX
	//	max_warning	not set for StatusSetPointX
	//	min_warning	not set for StatusSetPointX
	//	delta_t	not set for StatusSetPointX
	//	delta_val	not set for StatusSetPointX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_StatusSetPointX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_StatusSetPointX_dynamic_attribute
	statussetpointx->set_default_properties(statussetpointx_prop);
	//	Not Polled
	statussetpointx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	StatusSetPointX_data.insert(make_pair(attname, false));
	add_attribute(statussetpointx);
}
//--------------------------------------------------------
/**
 *	remove a StatusSetPointX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_StatusSetPointX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=StatusSetPointX_data.find(attname))!=StatusSetPointX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_StatusSetPointX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_StatusSetPointX_dynamic_attribute
		StatusSetPointX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a InterlockStatusX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_InterlockStatusX_dynamic_attribute(string attname)
{
	//	Attribute : InterlockStatusX
	InterlockStatusXAttrib	*interlockstatusx = new InterlockStatusXAttrib(attname);
	Tango::UserDefaultAttrProp	interlockstatusx_prop;
	//	description	not set for InterlockStatusX
	//	label	not set for InterlockStatusX
	//	unit	not set for InterlockStatusX
	//	standard_unit	not set for InterlockStatusX
	//	display_unit	not set for InterlockStatusX
	//	format	not set for InterlockStatusX
	//	max_value	not set for InterlockStatusX
	//	min_value	not set for InterlockStatusX
	//	max_alarm	not set for InterlockStatusX
	//	min_alarm	not set for InterlockStatusX
	//	max_warning	not set for InterlockStatusX
	//	min_warning	not set for InterlockStatusX
	//	delta_t	not set for InterlockStatusX
	//	delta_val	not set for InterlockStatusX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_InterlockStatusX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_InterlockStatusX_dynamic_attribute
	interlockstatusx->set_default_properties(interlockstatusx_prop);
	//	Not Polled
	interlockstatusx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	InterlockStatusX_data.insert(make_pair(attname, false));
	add_attribute(interlockstatusx);
}
//--------------------------------------------------------
/**
 *	remove a InterlockStatusX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_InterlockStatusX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=InterlockStatusX_data.find(attname))!=InterlockStatusX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_InterlockStatusX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_InterlockStatusX_dynamic_attribute
		InterlockStatusX_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a StatMaskX dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void Agilent4uhv::add_StatMaskX_dynamic_attribute(string attname)
{
	//	Attribute : StatMaskX
	StatMaskXAttrib	*statmaskx = new StatMaskXAttrib(attname);
	Tango::UserDefaultAttrProp	statmaskx_prop;
	//	description	not set for StatMaskX
	//	label	not set for StatMaskX
	//	unit	not set for StatMaskX
	//	standard_unit	not set for StatMaskX
	//	display_unit	not set for StatMaskX
	//	format	not set for StatMaskX
	//	max_value	not set for StatMaskX
	//	min_value	not set for StatMaskX
	//	max_alarm	not set for StatMaskX
	//	min_alarm	not set for StatMaskX
	//	max_warning	not set for StatMaskX
	//	min_warning	not set for StatMaskX
	//	delta_t	not set for StatMaskX
	//	delta_val	not set for StatMaskX
	
	/*----- PROTECTED REGION ID(Agilent4uhv::att_StatMaskX_dynamic_attribute) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::att_StatMaskX_dynamic_attribute
	statmaskx->set_default_properties(statmaskx_prop);
	//	Not Polled
	statmaskx->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	StatMaskX_data.insert(make_pair(attname, 0));
	add_attribute(statmaskx);
}
//--------------------------------------------------------
/**
 *	remove a StatMaskX dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_StatMaskX_dynamic_attribute(string attname)
{
	remove_attribute(attname, true);
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=StatMaskX_data.find(attname))!=StatMaskX_data.end())
    {
    	/*----- PROTECTED REGION ID(Agilent4uhv::remove_StatMaskX_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::remove_StatMaskX_dynamic_attribute
		StatMaskX_data.erase(ite);
	}
}


//============================================================
//	Tool methods to get pointer on attribute data buffer 
//============================================================
//--------------------------------------------------------
/**
 *	Return a pointer on HVX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevState *Agilent4uhv::get_HVX_data_ptr(string &name)
{
	map<string,Tango::DevState>::iterator ite;
    if ((ite=HVX_data.find(name))==HVX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_HVX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on DeviceNumberX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevLong *Agilent4uhv::get_DeviceNumberX_data_ptr(string &name)
{
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=DeviceNumberX_data.find(name))==DeviceNumberX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_DeviceNumberX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on PowerMaxX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevLong *Agilent4uhv::get_PowerMaxX_data_ptr(string &name)
{
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=PowerMaxX_data.find(name))==PowerMaxX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_PowerMaxX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on VTargetX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevLong *Agilent4uhv::get_VTargetX_data_ptr(string &name)
{
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=VTargetX_data.find(name))==VTargetX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_VTargetX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on IProtectX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevLong *Agilent4uhv::get_IProtectX_data_ptr(string &name)
{
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=IProtectX_data.find(name))==IProtectX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_IProtectX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on SetPointX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *Agilent4uhv::get_SetPointX_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=SetPointX_data.find(name))==SetPointX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_SetPointX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on TemperatureHVX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *Agilent4uhv::get_TemperatureHVX_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=TemperatureHVX_data.find(name))==TemperatureHVX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_TemperatureHVX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on VoltageX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *Agilent4uhv::get_VoltageX_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=VoltageX_data.find(name))==VoltageX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_VoltageX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on CurrentX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *Agilent4uhv::get_CurrentX_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=CurrentX_data.find(name))==CurrentX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_CurrentX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on PressureX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *Agilent4uhv::get_PressureX_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=PressureX_data.find(name))==PressureX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_PressureX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on StateX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevState *Agilent4uhv::get_StateX_data_ptr(string &name)
{
	map<string,Tango::DevState>::iterator ite;
    if ((ite=StateX_data.find(name))==StateX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_StateX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on StatusX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevString *Agilent4uhv::get_StatusX_data_ptr(string &name)
{
	map<string,Tango::DevString>::iterator ite;
    if ((ite=StatusX_data.find(name))==StatusX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_StatusX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on AutoStartX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *Agilent4uhv::get_AutoStartX_data_ptr(string &name)
{
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=AutoStartX_data.find(name))==AutoStartX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_AutoStartX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on ProtectX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *Agilent4uhv::get_ProtectX_data_ptr(string &name)
{
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=ProtectX_data.find(name))==ProtectX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_ProtectX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on FixedX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *Agilent4uhv::get_FixedX_data_ptr(string &name)
{
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=FixedX_data.find(name))==FixedX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_FixedX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on StatusSetPointX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *Agilent4uhv::get_StatusSetPointX_data_ptr(string &name)
{
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=StatusSetPointX_data.find(name))==StatusSetPointX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_StatusSetPointX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on InterlockStatusX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *Agilent4uhv::get_InterlockStatusX_data_ptr(string &name)
{
	map<string,Tango::DevBoolean>::iterator ite;
    if ((ite=InterlockStatusX_data.find(name))==InterlockStatusX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_InterlockStatusX_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on StatMaskX data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevLong *Agilent4uhv::get_StatMaskX_data_ptr(string &name)
{
	map<string,Tango::DevLong>::iterator ite;
    if ((ite=StatMaskX_data.find(name))==StatMaskX_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"Agilent4uhv::get_StatMaskX_data_ptr()");
    }
	return  &(ite->second);
}


//=============================================================
//	Add/Remove dynamic command methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a OffHVX dynamic command.
 *
 *  parameter cmdname: command name to be cretated and added.
 *  parameter device:  Set this flag to true if the command must be added for only this device.
 */
//--------------------------------------------------------
void Agilent4uhv::add_OffHVX_dynamic_command(string cmdname, bool device)
{
	OffHVXClass	*pOffHVXCmd =
		new OffHVXClass(cmdname.c_str(),
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	add_command(pOffHVXCmd, device);
}
//--------------------------------------------------------
/**
 *	remove a OffHVX dynamic command.
 *
 *  parameter cmdname: command name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_OffHVX_dynamic_command(string cmdname)
{
	remove_command(cmdname, true);
}
//--------------------------------------------------------
/**
 *	Add a OnHVX dynamic command.
 *
 *  parameter cmdname: command name to be cretated and added.
 *  parameter device:  Set this flag to true if the command must be added for only this device.
 */
//--------------------------------------------------------
void Agilent4uhv::add_OnHVX_dynamic_command(string cmdname, bool device)
{
	OnHVXClass	*pOnHVXCmd =
		new OnHVXClass(cmdname.c_str(),
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	add_command(pOnHVXCmd, device);
}
//--------------------------------------------------------
/**
 *	remove a OnHVX dynamic command.
 *
 *  parameter cmdname: command name to be removed.
 */
//--------------------------------------------------------
void Agilent4uhv::remove_OnHVX_dynamic_command(string cmdname)
{
	remove_command(cmdname, true);
}

} //	namespace
